#pragma include <data/shaders/ShaderMathCommon.h>

uniform sampler2D tex0; // distortion normal map
uniform sampler2D tex1; // background

varying mediump vec2 TexCoord1;
varying highp vec2 TexCoord2;
varying highp vec2 TexCoord3;
varying lowp	vec4 Color;

void main (void)
{
	lowp vec2 texDistortColor = texture2D(tex0, TexCoord3).rg;

	texDistortColor = texDistortColor * 2.0 - 1.0;
	texDistortColor *= Color.a;
	
	mediump vec2 falloff = 1.0 - abs(TexCoord1 * 2.0 - 1.0);
	texDistortColor *= falloff;

	lowp vec3 texFinalColor = texture2D(tex1, TexCoord2 + texDistortColor).rgb;

	gl_FragColor = vec4(texFinalColor, 1.0);
}
