#pragma include <data/shaders/ShaderMathCommon.h>

attribute highp vec2	inVertex;
attribute mediump vec2  inTexCoord;
attribute lowp vec4		inColor;

uniform highp mat2		inPMVMatrix;
uniform mediump vec2	g_invCanvasSize;
uniform mediump float	g_ratio;

varying mediump	vec2	TexCoord1;
varying highp	vec2	TexCoord2;
varying highp	vec2	TexCoord3;
varying lowp vec4		Color;

void main(void)
{
	highp vec2 vertex;

	vertex.x = inVertex.x * inPMVMatrix[0][0] + inPMVMatrix[0][1];
	vertex.y = inVertex.y * inPMVMatrix[1][0] + inPMVMatrix[1][1];

	Color = inColor;
	Color.a *= 0.17; // distort amount

	gl_Position = vec4(vertex, 0.0, 1.0);

	TexCoord1 = inTexCoord;

	// convert texture coords to screen coords
	TexCoord2 = (vertex * 0.5 + 0.5) * g_invCanvasSize;

	// scale normal map coords, to increase size
	float ratio = 1.0 / ((1.0 - g_ratio) + 0.5);
	TexCoord3 = (inTexCoord - 0.5) * ratio + 0.5;
}
