#pragma include <data/shaders/ShaderMathCommon.h>

attribute highp vec2	inVertex;
attribute mediump vec2  inTexCoord;
attribute lowp vec4		inColor;

uniform highp mat2		inPMVMatrix;
uniform highp vec2		g_canvasSize;

varying mediump	vec2	TexCoord1;
varying mediump	vec2	TexCoord2;
varying lowp vec4		Color;

void main(void)
{
	highp vec2 vertex;

	vertex.x = inVertex.x * inPMVMatrix[0][0] + inPMVMatrix[0][1];
	vertex.y = inVertex.y * inPMVMatrix[1][0] + inPMVMatrix[1][1];

	Color = inColor;

	gl_Position = vec4(vertex, 0.0, 1.0);

	TexCoord1 = inTexCoord;

	// convert texture coords to screen coords
	TexCoord2 = (vertex * 0.5 + 0.5) * g_canvasSize;
}
