attribute highp vec2	inVertex;
attribute mediump vec2  inTexCoord;
attribute lowp vec4		inColor;

uniform highp mat2		inPMVMatrix;
uniform highp vec2		g_bkgCanvasOffset;
uniform highp vec2		g_bkgInvCanvasSize;
uniform highp vec2		g_bkgTextureSize;
uniform highp vec2		g_bkgWallsAspectRatio;
uniform highp vec4		g_bkgWallsTransform; // scroll + zoom + time

uniform highp vec2		g_fovCanvasOffset;
uniform highp vec2		g_fovCanvasScale;

varying mediump	vec2	TexCoord;
varying highp	vec2	TexCoordFOVAccum;
varying highp	vec2	TexCoordBackground;
varying highp	vec2	TexCoordBackgroundWalls;
varying lowp vec4		Color;

void main(void)
{
	highp vec2 vertex;

	vertex.x = inVertex.x * inPMVMatrix[0][0] + inPMVMatrix[0][1];
	vertex.y = inVertex.y * inPMVMatrix[1][0] + inPMVMatrix[1][1];

	Color = inColor;

	gl_Position = vec4(vertex, 0.0, 1.0);
	TexCoord = inTexCoord;
	TexCoordFOVAccum = (inTexCoord + g_fovCanvasOffset) * g_fovCanvasScale;
	TexCoordBackground = (inTexCoord * g_bkgTextureSize + g_bkgCanvasOffset) * g_bkgInvCanvasSize;
	TexCoordBackgroundWalls = (inVertex * g_bkgWallsAspectRatio * 0.5 + g_bkgWallsTransform.xy) / g_bkgWallsTransform.w * 0.7;// - g_bkgWallsTransform.z * vec2(1.0, 0.5);
}
