uniform sampler2D		texBackground;
uniform sampler2D		texFOV;
uniform sampler2D		texEmpty;
uniform sampler2D		texEmptyWalls;

uniform highp vec4		g_sampleOffsets[2];

varying lowp vec2		TexCoord;
varying highp vec2		TexCoordFOVAccum;
varying highp vec2		TexCoordBackground;
varying highp vec2		TexCoordBackgroundWalls;

mediump float SampleFOV()
{
	lowp float color = texture2D(texFOV, TexCoord + g_sampleOffsets[0].xy).r;
	color += texture2D(texFOV, TexCoord + g_sampleOffsets[0].zw).r;
	color += texture2D(texFOV, TexCoord + g_sampleOffsets[1].xy).r;
	color += texture2D(texFOV, TexCoord + g_sampleOffsets[1].zw).r;
	return (color * 0.25);
}

void main (void)
{
	lowp vec4 texScreenColor = texture2D(texBackground, TexCoord);

	lowp float texFOVColor = texture2D(texFOV, TexCoordFOVAccum).b;//SampleFOV();//
	texFOVColor += texScreenColor.a;
	texFOVColor = min(texFOVColor, 1.0);
	lowp float brightness = 0.6 + texFOVColor * 0.4;

	lowp vec3 finalColor = texScreenColor.rgb * brightness;
	gl_FragColor = vec4(finalColor, 1.0);
}
