#ifdef USE_TEXTURE
uniform sampler2D tex0;
varying mediump vec2 TexCoord;
#endif

#ifdef VERTEX_COLOR
varying lowp vec4 Color;
#endif

#ifdef CONSTANT_COLOR
uniform lowp vec4 g_constantColor;
#endif

#ifdef GLOBAL_COLOR
uniform lowp vec4 g_globalColor; // multiplied with the current texture/color
#endif

void main (void)
{
#ifdef USE_TEXTURE
	lowp float texChannel = texture2D(tex0, TexCoord).r;
	lowp vec4 texColor = vec4( texChannel, texChannel, texChannel, texChannel );
#elif defined(CONSTANT_COLOR)
	lowp vec4 texColor = g_constantColor;
#else
	lowp vec4 texColor = vec4(1.0, 1.0, 1.0, 1.0);
#endif
	
#ifdef VERTEX_COLOR
	texColor *= Color;
#endif

#ifdef GLOBAL_COLOR
	texColor *= g_globalColor;
#endif


	gl_FragColor = texColor;
}
