#pragma include <data/shaders/ShaderMathCommon.h>

uniform sampler2D		tex0;
uniform sampler2D		tex1;
uniform sampler2D		texMask;

varying mediump vec2	TexCoord;
varying mediump vec2	TexCoordMask;
varying lowp vec4       Color;

void main (void)
{
	lowp vec3 tex1Color = texture2D(tex0, TexCoord).rgb;
	lowp vec3 tex2Color = texture2D(tex1, TexCoord).rgb;
	lowp float texMaskColor = texture2D(texMask, TexCoordMask).r;

	lowp vec3 finalColor = lerp(tex1Color, tex2Color, texMaskColor);
	gl_FragColor = vec4(finalColor, 0.0);
}
