attribute highp vec2	inVertex;
attribute mediump vec2  inTexCoord;
attribute lowp vec4		inColor;

uniform highp mat2		inPMVMatrix;
uniform mediump vec2	g_maskOffset;
uniform mediump vec2	g_maskScale;

varying mediump	vec2	TexCoord;
varying mediump	vec2	TexCoordMask;
varying lowp vec4		Color;

void main(void)
{
	highp vec2 vertex;

	vertex.x = inVertex.x * inPMVMatrix[0][0] + inPMVMatrix[0][1];
	vertex.y = inVertex.y * inPMVMatrix[1][0] + inPMVMatrix[1][1];

	Color = inColor;

	gl_Position = vec4(vertex, 0.0, 1.0);
	TexCoord = inTexCoord;
	TexCoordMask = (inTexCoord + g_maskOffset) * g_maskScale;
}
