#if defined(USE_TEXTURE) || defined(RGB_TEXTURE_WITH_ALPHA)
uniform sampler2D tex0;
varying mediump vec2 TexCoord;
#endif

#ifdef VERTEX_COLOR
varying lowp vec4 Color;
#endif

#ifdef CONSTANT_COLOR
uniform lowp vec4 g_constantColor;
#endif

#ifdef GLOBAL_COLOR
uniform lowp vec4 g_globalColor; // multiplied with the current texture/color
#endif

void main (void)
{
#ifdef RGB_TEXTURE_WITH_ALPHA
	// color is top, alpha is bottom
	mediump vec2 halfTexCoord = TexCoord * vec2(1.0, 0.5);
	lowp vec4 texColor = texture2D(tex0, halfTexCoord + vec2(0.0, 0.5));
	texColor.a = texture2D(tex0, halfTexCoord).r;
#elif defined(USE_TEXTURE)
	lowp vec4 texColor = texture2D(tex0, TexCoord);
#elif defined(CONSTANT_COLOR)
	lowp vec4 texColor = g_constantColor;
#else
	lowp vec4 texColor = vec4(1.0, 1.0, 1.0, 1.0);
#endif
	
#ifdef VERTEX_COLOR
	texColor *= Color;
#endif

#ifdef GLOBAL_COLOR
	texColor *= g_globalColor;
#endif

	gl_FragColor = texColor;
}
