// attributes
#ifdef INDEXED
attribute highp float	inVertex;//index into inQuadCoords
#else
attribute highp vec2	inVertex;
#endif
attribute mediump vec2  inTexCoord;

#ifdef VERTEX_COLOR
attribute lowp vec4		inColor;
#endif

// varyings
#ifdef VERTEX_COLOR
varying lowp  vec4		Color;
#endif
varying mediump	vec2	TexCoord;

// uniforms
uniform highp mat2		inPMVMatrix;
#ifdef TEXCOORDS_MATRIX
uniform highp mat3		inTexCoordMatrix; // used for animations and such
#endif
#ifdef INDEXED
uniform highp	vec2	inQuadCoords[4];
#endif

void main(void)
{
	highp vec2 vertex;

#ifdef INDEXED
	vertex   = inQuadCoords[int(inVertex)];
	vertex.x = vertex.x * inPMVMatrix[0][0] + inPMVMatrix[0][1];
	vertex.y = vertex.y * inPMVMatrix[1][0] + inPMVMatrix[1][1];	
#else
	vertex.x = inVertex.x * inPMVMatrix[0][0] + inPMVMatrix[0][1];
	vertex.y = inVertex.y * inPMVMatrix[1][0] + inPMVMatrix[1][1];
#endif

#ifdef VERTEX_COLOR
	Color = inColor;
#endif

	gl_Position = vec4(vertex, 0.0, 1.0);

#ifdef TEXCOORDS_MATRIX
	mediump vec3 tc3 = inTexCoordMatrix * vec3(inTexCoord, 1.0);
	TexCoord = tc3.xy;
#else
	TexCoord = inTexCoord;
#endif
}
