////////////////////////////////////////////////////////////////////////////
////  math functions ///////////////////////////////

mediump float lerp(mediump float a, mediump float b, mediump float ratio)
{
	return (a + ratio * (b - a));
}

mediump vec3 lerp(mediump vec3 a, mediump vec3 b, mediump float ratio)
{
	return (a + ratio * (b - a));
}

mediump vec3 lerp(mediump vec3 a, mediump vec3 b, mediump vec3 ratio)
{
	return (a + ratio * (b - a));
}

mediump vec3 lerp(mediump float a, mediump float b, mediump vec3 ratio)
{
	mediump vec3 a3 = vec3(a, a, a);
	return (a3 + ratio * (vec3(b, b, b) - a3));
}

mediump vec3 lerp(mediump float a, mediump vec3 b, mediump vec3 ratio)
{
	mediump vec3 a3 = vec3(a, a, a);
	return (a3 + ratio * (b - a3));
}

mediump vec3 lerp(mediump float a, mediump vec3 b, mediump float ratio)
{
	mediump float a1 = a * (1.0 - ratio);
	return (vec3(a1, a1, a1) + ratio * b);
}

mediump vec3 lerp(mediump vec3 a, mediump float b, mediump float ratio)
{
	mediump float b1 = b * ratio;
	return (a * (1.0 - ratio) + vec3(b1, b1, b1));
}

mediump float saturate(mediump float f)
{
	return clamp(f, 0.0, 1.0);
}

mediump vec3 GammaCorrection(mediump vec3 color, mediump float invGamma)
{
	return pow(color, vec3(invGamma, invGamma, invGamma));
}
