uniform sampler2D tex0;
varying mediump vec2 TexCoord;
varying lowp vec4 Color;

uniform lowp vec2 g_direction;
uniform lowp float g_angle;

void main (void)
{
	lowp vec4 texColor = texture2D(tex0, TexCoord);
	texColor *= Color;

	mediump vec2 texCoordNormalized = TexCoord * 2.0 - 1.0;
	mediump vec2 texDir = normalize(texCoordNormalized);
	mediump float angle = acos(texDir.x);
	//mediump float angle = acos(dot(texDir, g_direction));

	//texColor.a *= clamp(g_angle - angle, 0.0, 1.0);
	if (angle > g_angle)
		texColor.a = 0.0;

	gl_FragColor = texColor;
}
